﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

using WebSocketSharp;
using WebSocketSharp.Net;
using WebSocketSharp.Server;

public class WebSpeechAPI : MonoBehaviour {

    public static GameObject talkText;
    static string talkString = "";
    static MMD4M_LipSync lipSync;

    WebSocketServer server;
	// Use this for initialization
	void Start () {

        server = new WebSocketServer(12002);

        server.AddWebSocketService<MyServer>("/");
        server.Start();
        Debug.Log("Server(port=12002) for WebSpeechAPI started.");

        talkText = GameObject.FindWithTag("TalkText");
        lipSync = GameObject.FindWithTag("Gunman").GetComponent<MMD4M_LipSync>();
        lipSync.Talk(talkText.GetComponent<Text>().text);

        WebSpeechAPI.talkString = talkText.GetComponent<Text>().text;
        MyServer.webSpeechAPIeventHandler += eventHandler;

    }

    static void eventHandler(object sender, EventArgs e)
    {
        string talkString = ((MessageEventArgs)e).Data;

        Debug.Log("eventHandler() called : " + talkString);
        WebSpeechAPI.talkString = talkString;
        lipSync.Talk(talkString);

    }

    void OnDestroy()
    {
        server.Stop();
        server = null;
    }

    // Update is called once per frame
    void Update()
    {
        talkText.GetComponent<Text>().text = talkString;

    }

    public static void setTalkString(string talkString)
    {
        WebSpeechAPI.talkString = talkString;
    } 

}

public class MyServer : WebSocketBehavior
{
    public static event EventHandler webSpeechAPIeventHandler;
    protected override void OnMessage(MessageEventArgs e)
    {
        Debug.Log(e.Data);
//        WebSpeechAPI.setTalkString(e.Data);
        webSpeechAPIeventHandler(this, e);
    }
}


public class Sample {
private WebSocket ws_;

void clientSample()
{
    ws_ = new WebSocket("ws://127.0.0.1:12002");
    ws_.OnMessage += (sender, e) => {
        Debug.Log(e.Data); // 認識結果
    };
    ws_.Connect();
}

void OnApplicationQuit()
{
    ws_.Close();
}
}
